/* Generated by re2c 0.13.5 */
#line 1 "_mwscan.re"
// -*- mode: c++ -*-
// Copyright (c) 2007-2008 PediaPress GmbH
// See README.txt for additional licensing information.

#include <Python.h>

#include <iostream>
#include <assert.h>
#include <vector>
using namespace std;

#define RET(x) {found(x); return x;}

typedef enum {
	t_end,
	t_text,
	t_entity,
	t_special,
	t_magicword,
	t_comment,
	t_2box_open,   // [[
	t_2box_close,  // ]]
	t_http_url,
	t_break,
	t_begin_table,
	t_end_table,
	t_html_tag,
	t_style,
	t_pre,
	t_section,
	t_section_end,
	t_item,
	t_colon,
	t_semicolon,
	t_hrule,
	t_newline,
	t_column,
	t_row,
	t_tablecaption,
	t_urllink,
} mwtok;

struct Token
{
	int type;
	int start;
	int len;
};

class Scanner
{
public:

	Scanner(Py_UNICODE *_start, Py_UNICODE *_end) {
		source = start = _start;
		end = _end;
		cursor = start;
		line_startswith_section = -1;
		tablemode=0;
	}

	int found(mwtok val) {
		if (val==t_text && tokens.size()) {
			Token &previous_token (tokens[tokens.size()-1]);
			if (previous_token.type==val) {
				previous_token.len += cursor-start;
				return tokens.size()-1;
			}
		}
		Token t;
		t.type = val;
		t.start = (start-source);
		t.len = cursor-start;			
		tokens.push_back(t);
		return tokens.size()-1;
	}

	bool bol() {
		if ((start==source) || (start[-1]=='\n')) {
			memset(&lineflags, 0, sizeof(lineflags));
			return true;
		} else {
			return false;
		}
	}

	bool eol() const {
		return *cursor=='\n' || *cursor==0;
	}

	void newline() {
		if (line_startswith_section>=0) {
			tokens[line_startswith_section].type = t_text;
		}
		line_startswith_section = -1;
	}

	inline int scan();

	Py_UNICODE *source;

	Py_UNICODE *start;
	Py_UNICODE *cursor;
	Py_UNICODE *end;
	vector<Token> tokens;

	int line_startswith_section;
	int tablemode;
	struct {
		int rowchar;
	} lineflags;
};


int Scanner::scan()
{
	start=cursor;
	
	Py_UNICODE *marker=cursor;

	Py_UNICODE *save_cursor = cursor;


#define YYCTYPE         Py_UNICODE
#define YYCURSOR        cursor
#define YYMARKER	marker
#define YYLIMIT   (end)
// #define YYFILL(n) return 0;

#line 132 "_mwscan.re"


/*
  the re2c manpage says:
  "The user must arrange for a sentinel token to appear at the end of input"
  \000 is our sentinel token.
*/

#line 165 "_mwscan.re"

	if (!bol()) {
		goto not_bol;
	}

#line 148 "_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	yych = *YYCURSOR;
	if (yych <= '-') {
		if (yych <= '"') {
			if (yych <= 0x001F) goto yy18;
			if (yych <= ' ') goto yy2;
			if (yych <= '!') goto yy10;
			goto yy18;
		} else {
			if (yych <= ')') {
				if (yych <= '#') goto yy13;
				goto yy18;
			} else {
				if (yych <= '*') goto yy13;
				if (yych <= ',') goto yy18;
				goto yy17;
			}
		}
	} else {
		if (yych <= '<') {
			if (yych <= '9') goto yy18;
			if (yych <= ':') goto yy4;
			if (yych <= ';') goto yy15;
			goto yy18;
		} else {
			if (yych <= 'z') {
				if (yych <= '=') goto yy11;
				goto yy18;
			} else {
				if (yych <= '{') goto yy6;
				if (yych <= '|') goto yy8;
				goto yy18;
			}
		}
	}
yy2:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych <= 0x001F) goto yy3;
		if (yych <= '!') goto yy48;
	} else {
		if (yych <= ':') goto yy48;
		if (yych <= 'z') goto yy3;
		if (yych <= '|') goto yy48;
	}
yy3:
#line 209 "_mwscan.re"
	{RET(t_pre);}
#line 201 "_mwscan.cc"
yy4:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '*') {
		if (yych == '#') goto yy27;
		if (yych >= '*') goto yy27;
	} else {
		if (yych <= ':') {
			if (yych >= ':') goto yy43;
		} else {
			if (yych == '{') goto yy45;
		}
	}
yy5:
#line 215 "_mwscan.re"
	{RET(t_colon);}
#line 218 "_mwscan.cc"
yy6:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '|') goto yy41;
yy7:
#line 219 "_mwscan.re"
	{goto not_bol;}
#line 225 "_mwscan.cc"
yy8:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= ',') {
		if (yych == '+') goto yy33;
	} else {
		if (yych <= '-') goto yy36;
		if (yych == '}') goto yy39;
	}
yy9:
#line 185 "_mwscan.re"
	{
		if (tablemode) {
		        lineflags.rowchar=cursor[-1];
			RET(t_column);
		}

		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 248 "_mwscan.cc"
yy10:
	yych = *++YYCURSOR;
	goto yy9;
yy11:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy31;
	goto yy30;
yy12:
#line 210 "_mwscan.re"
	{
			line_startswith_section = found(t_section);
			return t_section;
		}
#line 262 "_mwscan.cc"
yy13:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy28;
yy14:
#line 214 "_mwscan.re"
	{RET(t_item);}
#line 270 "_mwscan.cc"
yy15:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy26;
yy16:
#line 216 "_mwscan.re"
	{RET(t_semicolon);}
#line 278 "_mwscan.cc"
yy17:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '-') goto yy19;
	goto yy7;
yy18:
	yych = *++YYCURSOR;
	goto yy7;
yy19:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy21;
yy20:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept <= 0) {
			goto yy3;
		} else {
			goto yy5;
		}
	} else {
		goto yy7;
	}
yy21:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy20;
yy22:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy22;
#line 217 "_mwscan.re"
	{RET(t_hrule);}
#line 310 "_mwscan.cc"
yy25:
	++YYCURSOR;
	yych = *YYCURSOR;
yy26:
	if (yych == ';') goto yy25;
	goto yy16;
yy27:
	++YYCURSOR;
	yych = *YYCURSOR;
yy28:
	if (yych == '#') goto yy27;
	if (yych == '*') goto yy27;
	goto yy14;
yy29:
	++YYCURSOR;
	yych = *YYCURSOR;
yy30:
	if (yych == '\t') goto yy29;
	if (yych == ' ') goto yy29;
	goto yy12;
yy31:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy29;
		goto yy12;
	} else {
		if (yych <= ' ') goto yy29;
		if (yych == '=') goto yy31;
		goto yy12;
	}
yy33:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '+') goto yy33;
#line 199 "_mwscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 356 "_mwscan.cc"
yy36:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy36;
#line 174 "_mwscan.re"
	{
		if (tablemode) 
			RET(t_row);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 371 "_mwscan.cc"
yy39:
	++YYCURSOR;
#line 171 "_mwscan.re"
	{--tablemode; RET(t_end_table);}
#line 376 "_mwscan.cc"
yy41:
	++YYCURSOR;
#line 170 "_mwscan.re"
	{++tablemode; RET(t_begin_table);}
#line 381 "_mwscan.cc"
yy43:
	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '*') {
		if (yych == '#') goto yy27;
		if (yych <= ')') goto yy5;
		goto yy27;
	} else {
		if (yych <= ':') {
			if (yych <= '9') goto yy5;
			goto yy43;
		} else {
			if (yych != '{') goto yy5;
		}
	}
yy45:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy41;
	goto yy20;
yy46:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy33;
		goto yy9;
	} else {
		if (yych <= '-') goto yy36;
		if (yych == '}') goto yy39;
		goto yy9;
	}
yy47:
	++YYCURSOR;
	yych = *YYCURSOR;
yy48:
	if (yych <= '9') {
		if (yych <= 0x001F) goto yy20;
		if (yych <= ' ') goto yy47;
		if (yych >= '"') goto yy20;
	} else {
		if (yych <= 'z') {
			if (yych <= ':') goto yy50;
			goto yy20;
		} else {
			if (yych <= '{') goto yy45;
			if (yych <= '|') goto yy46;
			goto yy20;
		}
	}
	yych = *++YYCURSOR;
	goto yy9;
yy50:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == ':') goto yy50;
	if (yych == '{') goto yy45;
	goto yy20;
}
#line 220 "_mwscan.re"



not_bol:
	cursor = save_cursor;
	marker = cursor;


#line 448 "_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '\'') {
			if (yych <= ' ') {
				if (yych <= 0x0000) goto yy74;
				if (yych == '\n') goto yy65;
				goto yy76;
			} else {
				if (yych <= '!') goto yy68;
				if (yych <= '%') goto yy76;
				if (yych <= '&') goto yy73;
				goto yy71;
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy76;
				if (yych <= '9') goto yy61;
				if (yych <= ':') goto yy70;
				goto yy76;
			} else {
				if (yych <= '<') goto yy72;
				if (yych <= '=') goto yy63;
				if (yych <= '@') goto yy76;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '^') {
				if (yych <= '[') goto yy54;
				if (yych == ']') goto yy62;
				goto yy76;
			} else {
				if (yych <= '_') goto yy60;
				if (yych <= '`') goto yy76;
				if (yych <= 'e') goto yy61;
				goto yy58;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'h') goto yy59;
				if (yych <= 'l') goto yy61;
				goto yy56;
			} else {
				if (yych <= 'z') goto yy61;
				if (yych == '|') goto yy67;
				goto yy76;
			}
		}
	}
yy54:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '[':	goto yy251;
	case 'f':	goto yy254;
	case 'h':	goto yy253;
	case 'm':	goto yy255;
	default:	goto yy55;
	}
yy55:
#line 269 "_mwscan.re"
	{RET(t_special);}
#line 515 "_mwscan.cc"
yy56:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == 'a') goto yy239;
	goto yy123;
yy57:
#line 235 "_mwscan.re"
	{RET(t_text);}
#line 523 "_mwscan.cc"
yy58:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy231;
	goto yy123;
yy59:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy221;
	goto yy123;
yy60:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy124;
	goto yy123;
yy61:
	yych = *++YYCURSOR;
	goto yy123;
yy62:
	yych = *++YYCURSOR;
	if (yych == ']') goto yy120;
	goto yy55;
yy63:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy118;
	goto yy117;
yy64:
#line 238 "_mwscan.re"
	{
			if (eol()) {
			        if (line_startswith_section>=0) {
				     line_startswith_section=-1;
				     RET(t_section_end);
                                } else {
				     RET(t_text);
                                }
			} else {
				RET(t_text);
			}
		    }
#line 561 "_mwscan.cc"
yy65:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '\n') goto yy113;
#line 251 "_mwscan.re"
	{newline(); RET(t_newline);}
#line 567 "_mwscan.cc"
yy67:
	yych = *++YYCURSOR;
	if (yych <= '*') {
		if (yych == '!') goto yy109;
		goto yy55;
	} else {
		if (yych <= '+') goto yy111;
		if (yych == '|') goto yy109;
		goto yy55;
	}
yy68:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '!') goto yy109;
yy69:
#line 279 "_mwscan.re"
	{RET(t_text);}
#line 584 "_mwscan.cc"
yy70:
	yych = *++YYCURSOR;
	goto yy55;
yy71:
	yych = *++YYCURSOR;
	if (yych == '\'') goto yy104;
	goto yy69;
yy72:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych == '!') goto yy88;
		if (yych <= '.') goto yy69;
		goto yy89;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy69;
			goto yy90;
		} else {
			if (yych <= '`') goto yy69;
			if (yych <= 'z') goto yy90;
			goto yy69;
		}
	}
yy73:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych == '#') goto yy77;
		if (yych <= '/') goto yy69;
		goto yy79;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy69;
			goto yy79;
		} else {
			if (yych <= '`') goto yy69;
			if (yych <= 'z') goto yy79;
			goto yy69;
		}
	}
yy74:
	++YYCURSOR;
#line 278 "_mwscan.re"
	{newline(); return t_end;}
#line 630 "_mwscan.cc"
yy76:
	yych = *++YYCURSOR;
	goto yy69;
yy77:
	yych = *++YYCURSOR;
	if (yych <= 'W') {
		if (yych <= '/') goto yy78;
		if (yych <= '9') goto yy84;
	} else {
		if (yych <= 'X') goto yy83;
		if (yych == 'x') goto yy83;
	}
yy78:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept <= 0) {
			goto yy55;
		} else {
			goto yy69;
		}
	} else {
		if (yyaccept <= 2) {
			goto yy105;
		} else {
			goto yy57;
		}
	}
yy79:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy78;
		if (yych <= '9') goto yy79;
		if (yych <= ':') goto yy78;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy78;
			goto yy79;
		} else {
			if (yych <= '`') goto yy78;
			if (yych <= 'z') goto yy79;
			goto yy78;
		}
	}
yy81:
	++YYCURSOR;
#line 276 "_mwscan.re"
	{RET(t_entity);}
#line 679 "_mwscan.cc"
yy83:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy78;
	goto yy87;
yy84:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '/') goto yy78;
	if (yych <= '9') goto yy84;
	if (yych == ';') goto yy81;
	goto yy78;
yy86:
	++YYCURSOR;
	yych = *YYCURSOR;
yy87:
	if (yych <= ';') {
		if (yych <= '/') goto yy78;
		if (yych <= '9') goto yy86;
		if (yych <= ':') goto yy78;
		goto yy81;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy78;
			goto yy86;
		} else {
			if (yych <= '`') goto yy78;
			if (yych <= 'f') goto yy86;
			goto yy78;
		}
	}
yy88:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy96;
	goto yy78;
yy89:
	yych = *++YYCURSOR;
	if (yych <= '@') goto yy78;
	if (yych <= 'Z') goto yy90;
	if (yych <= '`') goto yy78;
	if (yych >= '{') goto yy78;
yy90:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= ';') {
			if (yych <= 0x0000) goto yy78;
		} else {
			if (yych <= '<') goto yy78;
			if (yych >= '>') goto yy94;
		}
	} else {
		if (yych <= 'Z') {
			if (yych >= 'A') goto yy90;
		} else {
			if (yych <= '`') goto yy92;
			if (yych <= 'z') goto yy90;
		}
	}
yy92:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '<') {
		if (yych <= 0x0000) goto yy78;
		if (yych <= ';') goto yy92;
		goto yy78;
	} else {
		if (yych != '>') goto yy92;
	}
yy94:
	++YYCURSOR;
#line 272 "_mwscan.re"
	{RET(t_html_tag);}
#line 752 "_mwscan.cc"
yy96:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy78;
yy97:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy78;
		if (yych != '-') goto yy97;
	} else {
		if (yych == '=') goto yy97;
		if (yych <= '>') goto yy78;
		goto yy97;
	}
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy78;
		if (yych != '-') goto yy97;
	} else {
		if (yych == '=') goto yy97;
		if (yych <= '>') goto yy78;
		goto yy97;
	}
yy100:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy78;
		if (yych == '-') goto yy100;
		goto yy97;
	} else {
		if (yych <= '<') goto yy78;
		if (yych != '>') goto yy97;
	}
	++YYCURSOR;
#line 275 "_mwscan.re"
	{RET(t_comment);}
#line 791 "_mwscan.cc"
yy104:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '\'') goto yy106;
yy105:
#line 270 "_mwscan.re"
	{RET(t_style);}
#line 798 "_mwscan.cc"
yy106:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != '\'') goto yy105;
	yych = *++YYCURSOR;
	if (yych != '\'') goto yy78;
	yych = *++YYCURSOR;
	goto yy105;
yy109:
	++YYCURSOR;
#line 253 "_mwscan.re"
	{
		if (tablemode) {
		        if (cursor[-2]!='!' || cursor[-2]==lineflags.rowchar) {
			       RET(t_column);
			}
		}
		cursor = start+1;
		RET(t_special);
	}
#line 819 "_mwscan.cc"
yy111:
	++YYCURSOR;
#line 263 "_mwscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		cursor = start+1;
		RET(t_special);
	}
#line 829 "_mwscan.cc"
yy113:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '\n') goto yy113;
#line 250 "_mwscan.re"
	{newline(); RET(t_break);}
#line 836 "_mwscan.cc"
yy116:
	++YYCURSOR;
	yych = *YYCURSOR;
yy117:
	if (yych == '\t') goto yy116;
	if (yych == ' ') goto yy116;
	goto yy64;
yy118:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy116;
		goto yy64;
	} else {
		if (yych <= ' ') goto yy116;
		if (yych == '=') goto yy118;
		goto yy64;
	}
yy120:
	++YYCURSOR;
#line 237 "_mwscan.re"
	{RET(t_2box_close);}
#line 859 "_mwscan.cc"
yy122:
	++YYCURSOR;
	yych = *YYCURSOR;
yy123:
	if (yych <= 'Z') {
		if (yych <= '/') goto yy57;
		if (yych <= '9') goto yy122;
		if (yych <= '@') goto yy57;
		goto yy122;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy57;
			goto yy122;
		} else {
			if (yych <= '`') goto yy57;
			if (yych <= 'z') goto yy122;
			goto yy57;
		}
	}
yy124:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'E':	goto yy128;
	case 'F':	goto yy127;
	case 'N':	goto yy126;
	case 'S':	goto yy129;
	case 'T':	goto yy125;
	default:	goto yy123;
	}
yy125:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy218;
	goto yy123;
yy126:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy148;
	if (yych == 'O') goto yy149;
	goto yy123;
yy127:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy140;
	goto yy123;
yy128:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy137;
	goto yy123;
yy129:
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
yy135:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= 'Z') {
		if (yych <= '/') goto yy136;
		if (yych <= '9') goto yy122;
		if (yych >= 'A') goto yy122;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy122;
		} else {
			if (yych <= '`') goto yy136;
			if (yych <= 'z') goto yy122;
		}
	}
yy136:
#line 234 "_mwscan.re"
	{RET(t_magicword);}
#line 936 "_mwscan.cc"
yy137:
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy140:
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy148:
	yych = *++YYCURSOR;
	if (yych == 'W') goto yy205;
	goto yy123;
yy149:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'C':	goto yy152;
	case 'E':	goto yy151;
	case 'G':	goto yy153;
	case 'T':	goto yy150;
	default:	goto yy123;
	}
yy150:
	yych = *++YYCURSOR;
	if (yych <= 'H') {
		if (yych == 'C') goto yy188;
		goto yy123;
	} else {
		if (yych <= 'I') goto yy189;
		if (yych == 'O') goto yy190;
		goto yy123;
	}
yy151:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy177;
	goto yy123;
yy152:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy161;
	if (yych == 'O') goto yy162;
	goto yy123;
yy153:
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'Y') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy161:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy176;
	goto yy123;
yy162:
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy176:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy177:
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy188:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy204;
	goto yy123;
yy189:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy193;
	goto yy123;
yy190:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy193:
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy204:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy205:
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'K') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy218:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy135;
	goto yy123;
yy221:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy123;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy225;
	if (yych != 's') goto yy123;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy123;
yy225:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= '_') {
		if (yych <= ':') {
			if (yych <= '&') {
				if (yych == '#') goto yy228;
				if (yych <= '$') goto yy78;
			} else {
				if (yych <= '\'') goto yy78;
				if (yych == '*') goto yy78;
			}
		} else {
			if (yych <= '?') {
				if (yych == '=') goto yy228;
				if (yych <= '>') goto yy78;
			} else {
				if (yych <= '@') goto yy78;
				if (yych <= 'Z') goto yy228;
				if (yych <= '^') goto yy78;
			}
		}
	} else {
		if (yych <= 0x00D6) {
			if (yych <= '~') {
				if (yych <= '`') goto yy78;
				if (yych <= 'z') goto yy228;
				if (yych <= '}') goto yy78;
			} else {
				if (yych == 0x00C4) goto yy228;
				if (yych <= 0x00D5) goto yy78;
			}
		} else {
			if (yych <= 0x00E4) {
				if (yych == 0x00DC) goto yy228;
				if (yych <= 0x00E3) goto yy78;
			} else {
				if (yych <= 0x00F6) {
					if (yych <= 0x00F5) goto yy78;
				} else {
					if (yych != 0x00FC) goto yy78;
				}
			}
		}
	}
yy228:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ':') {
			if (yych <= '&') {
				if (yych == '#') goto yy228;
				if (yych >= '%') goto yy228;
			} else {
				if (yych <= '\'') goto yy230;
				if (yych != '*') goto yy228;
			}
		} else {
			if (yych <= '?') {
				if (yych == '=') goto yy228;
				if (yych >= '?') goto yy228;
			} else {
				if (yych <= '@') goto yy230;
				if (yych <= 'Z') goto yy228;
				if (yych >= '_') goto yy228;
			}
		}
	} else {
		if (yych <= 0x00D6) {
			if (yych <= '~') {
				if (yych <= '`') goto yy230;
				if (yych <= 'z') goto yy228;
				if (yych >= '~') goto yy228;
			} else {
				if (yych == 0x00C4) goto yy228;
				if (yych >= 0x00D6) goto yy228;
			}
		} else {
			if (yych <= 0x00E4) {
				if (yych == 0x00DC) goto yy228;
				if (yych >= 0x00E4) goto yy228;
			} else {
				if (yych <= 0x00F6) {
					if (yych >= 0x00F6) goto yy228;
				} else {
					if (yych == 0x00FC) goto yy228;
				}
			}
		}
	}
yy230:
#line 233 "_mwscan.re"
	{RET(t_http_url);}
#line 1263 "_mwscan.cc"
yy231:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy123;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy123;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= '=') {
		if (yych <= '&') {
			if (yych <= '"') goto yy78;
			if (yych == '%') goto yy78;
		} else {
			if (yych <= '\'') goto yy78;
			if (yych <= ':') goto yy236;
			if (yych <= '<') goto yy78;
		}
	} else {
		if (yych <= '_') {
			if (yych <= '>') goto yy78;
			if (yych <= 'Z') goto yy236;
			if (yych <= '^') goto yy78;
		} else {
			if (yych <= '{') {
				if (yych <= '`') goto yy78;
			} else {
				if (yych <= '|') goto yy78;
				if (yych >= 0x007F) goto yy78;
			}
		}
	}
yy236:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '=') {
		if (yych <= '&') {
			if (yych <= '"') goto yy238;
			if (yych != '%') goto yy236;
		} else {
			if (yych <= '\'') goto yy238;
			if (yych <= ':') goto yy236;
			if (yych >= '=') goto yy236;
		}
	} else {
		if (yych <= '_') {
			if (yych <= '>') goto yy238;
			if (yych <= 'Z') goto yy236;
			if (yych >= '_') goto yy236;
		} else {
			if (yych <= '{') {
				if (yych >= 'a') goto yy236;
			} else {
				if (yych <= '|') goto yy238;
				if (yych <= '~') goto yy236;
			}
		}
	}
yy238:
#line 231 "_mwscan.re"
	{RET(t_http_url);}
#line 1327 "_mwscan.cc"
yy239:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy123;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy123;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy123;
	yych = *++YYCURSOR;
	if (yych == '@') goto yy78;
	goto yy246;
yy245:
	++YYCURSOR;
	yych = *YYCURSOR;
yy246:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy245;
			if (yych <= '"') goto yy78;
			goto yy245;
		} else {
			if (yych <= ')') goto yy78;
			if (yych == ',') goto yy78;
			goto yy245;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy245;
			if (yych <= '>') goto yy78;
			goto yy245;
		} else {
			if (yych <= 'Z') {
				if (yych >= 'A') goto yy245;
			} else {
				if (yych <= ']') goto yy78;
				if (yych <= '~') goto yy245;
				goto yy78;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy78;
		} else {
			if (yych <= '/') goto yy78;
			if (yych >= ':') goto yy78;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy248;
			if (yych <= '^') goto yy78;
		} else {
			if (yych <= '`') goto yy78;
			if (yych >= '{') goto yy78;
		}
	}
yy248:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy248;
		} else {
			if (yych <= '/') goto yy250;
			if (yych <= '9') goto yy248;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy248;
			if (yych >= '_') goto yy248;
		} else {
			if (yych <= '`') goto yy250;
			if (yych <= 'z') goto yy248;
		}
	}
yy250:
#line 229 "_mwscan.re"
	{RET(t_http_url);}
#line 1411 "_mwscan.cc"
yy251:
	++YYCURSOR;
#line 236 "_mwscan.re"
	{RET(t_2box_open);}
#line 1416 "_mwscan.cc"
yy253:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy276;
	goto yy78;
yy254:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy268;
	goto yy78;
yy255:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy78;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if (yych == '@') goto yy78;
	goto yy263;
yy262:
	++YYCURSOR;
	yych = *YYCURSOR;
yy263:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy262;
			if (yych <= '"') goto yy78;
			goto yy262;
		} else {
			if (yych <= ')') goto yy78;
			if (yych == ',') goto yy78;
			goto yy262;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy262;
			if (yych <= '>') goto yy78;
			goto yy262;
		} else {
			if (yych <= 'Z') {
				if (yych >= 'A') goto yy262;
			} else {
				if (yych <= ']') goto yy78;
				if (yych <= '~') goto yy262;
				goto yy78;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy78;
		} else {
			if (yych <= '/') goto yy78;
			if (yych >= ':') goto yy78;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy265;
			if (yych <= '^') goto yy78;
		} else {
			if (yych <= '`') goto yy78;
			if (yych >= '{') goto yy78;
		}
	}
yy265:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy265;
		} else {
			if (yych <= '/') goto yy267;
			if (yych <= '9') goto yy265;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy265;
			if (yych >= '_') goto yy265;
		} else {
			if (yych <= '`') goto yy267;
			if (yych <= 'z') goto yy265;
		}
	}
yy267:
#line 228 "_mwscan.re"
	{RET(t_urllink);}
#line 1509 "_mwscan.cc"
yy268:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy78;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= '=') {
		if (yych <= '&') {
			if (yych <= '"') goto yy78;
			if (yych == '%') goto yy78;
		} else {
			if (yych <= '\'') goto yy78;
			if (yych <= ':') goto yy273;
			if (yych <= '<') goto yy78;
		}
	} else {
		if (yych <= '_') {
			if (yych <= '>') goto yy78;
			if (yych <= 'Z') goto yy273;
			if (yych <= '^') goto yy78;
		} else {
			if (yych <= '{') {
				if (yych <= '`') goto yy78;
			} else {
				if (yych <= '|') goto yy78;
				if (yych >= 0x007F) goto yy78;
			}
		}
	}
yy273:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '=') {
		if (yych <= '&') {
			if (yych <= '"') goto yy275;
			if (yych != '%') goto yy273;
		} else {
			if (yych <= '\'') goto yy275;
			if (yych <= ':') goto yy273;
			if (yych >= '=') goto yy273;
		}
	} else {
		if (yych <= '_') {
			if (yych <= '>') goto yy275;
			if (yych <= 'Z') goto yy273;
			if (yych >= '_') goto yy273;
		} else {
			if (yych <= '{') {
				if (yych >= 'a') goto yy273;
			} else {
				if (yych <= '|') goto yy275;
				if (yych <= '~') goto yy273;
			}
		}
	}
yy275:
#line 230 "_mwscan.re"
	{RET(t_urllink);}
#line 1572 "_mwscan.cc"
yy276:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy78;
	yych = *++YYCURSOR;
	if (yych == ':') goto yy280;
	if (yych != 's') goto yy78;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy78;
yy280:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= '_') {
		if (yych <= ':') {
			if (yych <= '&') {
				if (yych == '#') goto yy283;
				if (yych <= '$') goto yy78;
			} else {
				if (yych <= '\'') goto yy78;
				if (yych == '*') goto yy78;
			}
		} else {
			if (yych <= '?') {
				if (yych == '=') goto yy283;
				if (yych <= '>') goto yy78;
			} else {
				if (yych <= '@') goto yy78;
				if (yych <= 'Z') goto yy283;
				if (yych <= '^') goto yy78;
			}
		}
	} else {
		if (yych <= 0x00D6) {
			if (yych <= '~') {
				if (yych <= '`') goto yy78;
				if (yych <= 'z') goto yy283;
				if (yych <= '}') goto yy78;
			} else {
				if (yych == 0x00C4) goto yy283;
				if (yych <= 0x00D5) goto yy78;
			}
		} else {
			if (yych <= 0x00E4) {
				if (yych == 0x00DC) goto yy283;
				if (yych <= 0x00E3) goto yy78;
			} else {
				if (yych <= 0x00F6) {
					if (yych <= 0x00F5) goto yy78;
				} else {
					if (yych != 0x00FC) goto yy78;
				}
			}
		}
	}
yy283:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ':') {
			if (yych <= '&') {
				if (yych == '#') goto yy283;
				if (yych >= '%') goto yy283;
			} else {
				if (yych <= '\'') goto yy285;
				if (yych != '*') goto yy283;
			}
		} else {
			if (yych <= '?') {
				if (yych == '=') goto yy283;
				if (yych >= '?') goto yy283;
			} else {
				if (yych <= '@') goto yy285;
				if (yych <= 'Z') goto yy283;
				if (yych >= '_') goto yy283;
			}
		}
	} else {
		if (yych <= 0x00D6) {
			if (yych <= '~') {
				if (yych <= '`') goto yy285;
				if (yych <= 'z') goto yy283;
				if (yych >= '~') goto yy283;
			} else {
				if (yych == 0x00C4) goto yy283;
				if (yych >= 0x00D6) goto yy283;
			}
		} else {
			if (yych <= 0x00E4) {
				if (yych == 0x00DC) goto yy283;
				if (yych >= 0x00E4) goto yy283;
			} else {
				if (yych <= 0x00F6) {
					if (yych >= 0x00F6) goto yy283;
				} else {
					if (yych == 0x00FC) goto yy283;
				}
			}
		}
	}
yy285:
#line 232 "_mwscan.re"
	{RET(t_urllink);}
#line 1679 "_mwscan.cc"
}
#line 280 "_mwscan.re"

}


PyObject *py_scan(PyObject *self, PyObject *args) 
{
	PyObject *arg1;
	if (!PyArg_ParseTuple(args, "O:mwscan.scan", &arg1)) {
		return 0;
	}
	PyUnicodeObject *unistr = (PyUnicodeObject*)PyUnicode_FromObject(arg1);
	if (unistr == NULL) {
		PyErr_SetString(PyExc_TypeError,
				"parameter cannot be converted to unicode in mwscan.scan");
		return 0;
	}

	Py_UNICODE *start = unistr->str;
	Py_UNICODE *end = start+unistr->length;
	

	Scanner scanner (start, end);
	Py_BEGIN_ALLOW_THREADS
	while (scanner.scan()) {
	}
	Py_END_ALLOW_THREADS
	Py_XDECREF(unistr);
	
	// return PyList_New(0); // uncomment to see timings for scanning

	int size = scanner.tokens.size();
	PyObject *result = PyList_New(size);
	if (!result) {
		return 0;
	}
	
	for (int i=0; i<size; i++) {
		Token t = scanner.tokens[i];
		PyList_SET_ITEM(result, i, Py_BuildValue("iii", t.type, t.start, t.len));
	}
	
	return result;
}



static PyMethodDef module_functions[] = {
	{"scan", (PyCFunction)py_scan, METH_VARARGS, "scan(text)"},
	{0, 0},
};



extern "C" {
	DL_EXPORT(void) init_mwscan();
}

DL_EXPORT(void) init_mwscan()
{
	/*PyObject *m =*/ Py_InitModule("_mwscan", module_functions);
}
